#ifndef MOTORTAB_H
#define MOTORTAB_H

#include <QDialog>
#include <QtGui>

#define NUM_MOTORS 4

#define FREQ					0 //Valid for SIN and COS 
#define DELTA					1
#define STEP					2
#define RAMP 					3
#define PARABOLA			4
#define SIN						5
#define COS						6	
#define TRAPEZOIDAL		7
#define TRAPEZOIDAL2	8
#define EXP						9
#define EXP2					10

class MotorTab : public QWidget
{
	Q_OBJECT

	public:
		MotorTab ( void );

		unsigned char getMotorStatus 		( unsigned char u_motor );
		unsigned int 	getMotorPWMFreq 	( unsigned char u_motor );
		unsigned char getNumMotors 			( void );

		void 					enableMotor 			( unsigned char u_motor );
		void 					disableMotor			( unsigned char u_motor );
		void 					setMotorPWMFreq		( unsigned char u_motor, unsigned int u_freq );

	private:
		QLineEdit *IPValue;
		QSpinBox 	*portValue;

		QCheckBox		*motorOn[NUM_MOTORS];
		QSpinBox		*motorPWMFreq[NUM_MOTORS];
		QLabel			*motorFreqLabel[NUM_MOTORS];
};

#endif //NETWORKTAB_H
