#ifndef PERTURBATIONTAB_H
#define PERTURBATIONTAB_H

#include <QDialog>
#include <QtGui>

#include "motortab.h"
		
/*const QString controllersName[NUM_CONTROLLER_LOOPS] = {"Direct", "Parallel", "FeedBack", "FeedForward"};*/
/*const QString controllerParamsNamesGlobal[NUM_CONTROLLER_PARAM] = {"Kp", "Ki", "Kd", "Wup", "Ep"};*/
/*const QString controllerParamsNamesGlobal[NUM_CONTROLLER_PARAM] = {"Kp", "Ki", "Kd", "Wup"}; //Epsilon not used*/

class QTabWidget;

class PerturbationMotorTab : public QWidget
{
	Q_OBJECT

	public:
		PerturbationMotorTab ( void );
		
		/*QDoubleSpinBox 	*controllerParam[NUM_CONTROLLER_LOOPS][NUM_CONTROLLER_PARAM];*/
		QSpinBox				*Tsampling;
		QComboBox				*controllerType;
		
		QComboBox							*controlVar;
		QComboBox							*referenceType;
		QDoubleSpinBox				*referenceValue1;
		QDoubleSpinBox				*referenceValue2;
		QDoubleSpinBox				*referenceValue3;
		QDoubleSpinBox				*referenceValue4;
	
	private:
		void createController	( unsigned int num_controller );
		
		/*QGroupBox *controllerGroup[NUM_CONTROLLER_LOOPS];*/
		/*QString controllerParamsNames[NUM_CONTROLLER_PARAM];*/

	private slots:
		void handleReferenceTypeChanged(int index);	
};

class PerturbationTab : public QWidget
{
	Q_OBJECT

	public:
		PerturbationTab ( MotorTab *motor_tab );

		float 				getPerturbationParamValue 	( unsigned char u_motor , unsigned char u_controller, 
																							unsigned char u_param);
		unsigned char getNumControllers 				( void );
		unsigned char getNumParams 							( void );
		char* 				getPerturbationName 				( unsigned char u_controller );
		char* 				getPerturbationParamName 		( unsigned char u_controller );
		unsigned char getPerturbationType 				( unsigned char u_motor );
		unsigned int 	getPerturbationSamplingFreq ( unsigned char u_motor );

		unsigned char	getPerturbationControlVar 	( unsigned char u_motor );
		unsigned char	getPerturbationRefType			( unsigned char u_motor );
		float 				getPerturbationRefValue1		( unsigned char u_motor );
		float 				getPerturbationRefValue2		( unsigned char u_motor );
		float 				getPerturbationRefValue3		( unsigned char u_motor );
		float 				getPerturbationRefValue4		( unsigned char u_motor );
	
		void					enableController					( unsigned char u_motor );
		void 					disableController 				( unsigned char u_motor );

		void 					setPerturbationSamplingFreq	( unsigned char u_motor, unsigned int u_freq );
		void 					setPerturbationType					( unsigned char u_motor, unsigned char u_type );
		void					setPerturbationControlVar 	( unsigned char u_motor, unsigned char u_control_var );
		void 					setPerturbationRefType			( unsigned char u_motor, unsigned char u_ref_type );
		void  				setPerturbationRefValue1		( unsigned char u_motor, float f_ref_value );
		void	 				setPerturbationRefValue2		( unsigned char u_motor, float f_ref_value );
		void	 				setPerturbationRefValue3		( unsigned char u_motor, float f_ref_value );
		void	 				setPerturbationRefValue4		( unsigned char u_motor, float f_ref_value );
		void  				setPerturbationParamValue 	( unsigned char u_motor , unsigned char u_controller, 
																							unsigned char u_param, float f_value);

		PerturbationMotorTab	*perturbationMotorTab[NUM_MOTORS];
};
#endif//CONTROLLERTAB_H
