#include <QApplication>

//PLOTS
#include "qcustomplot.h"
#include "plotwindow.h"  
#include "camerawindow.h"  

#include "tabdialog.h"

#include "locale.h"

int main(int argc, char *argv[])
{
	setlocale( LC_ALL, "en_US" );

	/* Create Application */
	QApplication app(argc, argv);
	QString fileName;

	/* Create plot widget */
	PlotWindow *plot = new PlotWindow;

	/* Create camera widget*/
	CameraWindow *camera = new CameraWindow;

	/* Create tabdialog widget, passing plot widget*/
	TabDialog tabdialog(plot, camera);

	/* Configure Sizing */
	/* Get size of plot */
	QSize tabSize = tabdialog.sizeHint();

	/* Resize plot to be as hight as tabdialog */
	plot->resize(1.5*tabSize.width(),tabSize.height());
	/* Move plot to left-top corner */
	plot->move(0,0);
	/* Show plot window */
	plot->show();
	
	/* Move camera to the right of tabdialog */
	camera->move(2.7*tabSize.width(), 0);
	
	/* show camera */	
	camera->show();

	/* Set tabdialog flags */
	tabdialog.setWindowFlags(Qt::Window);
	/* Move tabdialog to the right of plot */
	tabdialog.move(1.65*tabSize.width(), 0);
	/* Show tabdialog window */
	tabdialog.show();

	
	/* Exec app */
 	return app.exec();
}
